=== debian/changelog ===
zziplib (0.13.78+dfsg.1-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Bump CMake policy version (Closes: #1113664)

 -- Timo Röhling <roehling@debian.org>  Sat, 27 Sep 2025 21:04:59 +0200

zziplib (0.13.78+dfsg.1-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTCBFS: Honour DEB_BUILD_OPTIONS=nocheck. (Closes: #1062794)
  * New upstream version. (Closes: #1075709, #1074424, CVE-2024-39134)
  * d/copyright: Convert to machine-readable format.
  * libzzip-dev: Add cmake files.

 -- Bastian Germann <bage@debian.org>  Tue, 25 Feb 2025 23:37:30 +0100

zziplib (0.13.72+dfsg.1-1.3) unstable; urgency=medium

  * Non-Maintainer Upload.
  * Drop myself from Uploaders, I added myself accidentally in the past.
  * d/control: Update Vcs-* fields, moving to 'debian' namespace

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Changed vcs type from git to Git based on URL.
  * Remove unnecessary get-orig-source-target.
  * Update standards version to 4.6.1, no changes needed.
  * Set upstream metadata fields: Repository.
  * Update standards version to 4.6.2, no changes needed.

 -- Lukas Märdian <slyon@debian.org>  Mon, 22 Jul 2024 16:59:32 +0200
