=== debian/watch ===
version=4
opts="dversionmangle=auto,repacksuffix=+dfsg.1" \
   https://github.com/gdraheim/zziplib/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
